------------------------------------------------------------
-- MyPetFrame.lua
--
-- Abin
-- 2011/1/31
------------------------------------------------------------

-- Classes those may have permenant pets
local PET_CLASSES = { HUNTER = 1, WARLOCK = 1, MAGE = 1, DEATHKNIGHT = 1 }
if not PET_CLASSES[select(2, UnitClass("player"))] then return end

local _, addon = ...
local manager = addon.thirdPartyManager

------------------------------------------------------------
-- Pet-party1 displaying mode (added in 1.3)
------------------------------------------------------------

local function PetFrame_OnEvent(self, event, unit, ...)
	if event == "UNIT_PET" then
		-- unit of this frame is always "pet" but I only check "player" here, that's why I cannot pass it to manager:ProcessEvent
		if unit == "player" then
			manager:UpdateFrame(self)
		end
	else
		manager:ProcessEvent(self, event, unit, ...)
	end
end

local frame = manager:CreateFrame("CompactPartyFrameMyPetFrame", CompactPartyFrame, "pet", "normal")
frame:SetAllPoints(CompactPartyFrameMember2)
manager.petFrame = frame
addon.layoutManager.partyAdjustFrames[frame] = 2
frame:SetScript("OnEvent", PetFrame_OnEvent)

-- Some events are meaningless for a pet, just unregister them to save a little of CPU cycles
frame:UnregisterEvent("UNIT_CONNECTION")
frame:UnregisterEvent("PLAYER_ROLES_ASSIGNED")
frame:UnregisterEvent("UNIT_ENTERED_VEHICLE")
frame:UnregisterEvent("UNIT_EXITED_VEHICLE")
frame:UnregisterEvent("READY_CHECK")
frame:UnregisterEvent("READY_CHECK_FINISHED")
frame:UnregisterEvent("READY_CHECK_CONFIRM")
frame:UnregisterEvent("PARTY_MEMBER_DISABLE")
frame:UnregisterEvent("PARTY_MEMBER_ENABLE")

RegisterStateDriver(frame, "visibility", "[pet, nogroup] show; hide")
RegisterStateDriver(CompactPartyFramePet1, "visibility", "[nogroup] hide")